unit UnitProperty;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, vg_TLB;

type
  TfrmUnitProperty = class(TForm)
    vg1: Tvgctrl;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmUnitProperty: TfrmUnitProperty;

implementation

{$R *.dfm}

procedure TfrmUnitProperty.FormShow(Sender: TObject);
begin
  vg1.Design( 'http://www.visual-graph.com/activex/property.xml' );
end;

procedure TfrmUnitProperty.Button1Click(Sender: TObject);
var
  d : ISheet;
begin
  d := vg1.vg.ActiveSheet;
  if d.FindProperty( 'Voltage' ) = -1 then
  begin
    d.AddProperty( 'Voltage', #0, #0, #0, true );
    d.SetPropertyValue( 'Voltage', '110' );
    ShowMessage( 'we have add a property "Voltage" to the switch which has a value "110".' );
  end;
  if d.FindProperty( 'Value' ) = -1 then
  begin
    d.AddFunction( 'GetValue', #0, 1 );
    d.AddFunction( 'SetValue', 'AValue', 1 );
    d.SetFunctionValue( 'GetValue', 'return Rect1.BackColor <> 0' );
    d.SetFunctionValue( 'SetValue', 'if Rect1.BackColor = 0 then; Rect1.BackColor = $FF; else; Rect1.BackColor = 0; end if' );
    d.AddProperty( 'Value', 'GetValue', 'SetValue', 'bool', true );
    ShowMessage( 'we have add a property "Value" to the switch which has a value "false".' );
  end;
end;

procedure TfrmUnitProperty.Button2Click(Sender: TObject);
var
  d : ISheet;
  e : IUnit;
begin
  d := vg1.vg.ActiveSheet;
  if d.UnitByName( 'Switch' ) = nil then
  begin
    e := d.CopyUnit( d );
    e.MoveBy( 100, 100 );
    vg1.vg.Selection.Clear();
    vg1.vg.Selection.Add( e );
  end;
end;

procedure TfrmUnitProperty.Button3Click(Sender: TObject);
var
  d : IUnit;
begin
  d := vg1.vg.ActiveSheet.UnitByName( 'Switch' );
  if d <> nil then
  begin
    d.SetPropertyValue( 'Voltage', '220' );
    ShowMessage( 'the switch has a property : Voltage = ' + d.GetPropertyValue( 'Voltage' ) );
  end;
end;

procedure TfrmUnitProperty.Button4Click(Sender: TObject);
var
  d : IUnit;
  b : Boolean;
begin
  d := vg1.vg.ActiveSheet.UnitByName( 'Switch' );
  if d <> nil then
  begin
    b := TVarData( d.GetPropertyValue( 'Value' ) ).Vboolean;
    d.SetPropertyValue( 'Value', not b );
    ShowMessage( 'the switch has a property : Value = ' + FloatToStr( d.GetPropertyValue( 'Value' ) ) );
  end;
end;

end.
