// ZoomAndTranslationDocument.cpp : implementation file
//

#include "stdafx.h"
#include "vg.h"
#include "group.h"
#include "sheet.h"
#include "unit.h"
#include "VC.h"
#include "ZoomAndTranslationDocument.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ZoomAndTranslationDocument dialog


ZoomAndTranslationDocument::ZoomAndTranslationDocument(CWnd* pParent /*=NULL*/)
  : CDialog(ZoomAndTranslationDocument::IDD, pParent)
{
  //{{AFX_DATA_INIT(ZoomAndTranslationDocument)
    // NOTE: the ClassWizard will add member initialization here
  //}}AFX_DATA_INIT
}


void ZoomAndTranslationDocument::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(ZoomAndTranslationDocument)
  DDX_Control(pDX, IDC_VGCTRL1, vg1);
  //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ZoomAndTranslationDocument, CDialog)
  //{{AFX_MSG_MAP(ZoomAndTranslationDocument)
  ON_WM_SIZE()
  ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
  ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
  ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
  ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
  ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
  ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ZoomAndTranslationDocument message handlers

BOOL ZoomAndTranslationDocument::OnInitDialog() 
{
  CDialog::OnInitDialog();
  
  vg1.Run("http://www.visual-graph.com/activex/map.xml");
  
  return TRUE;  // return TRUE unless you set the focus to a control
                // EXCEPTION: OCX Property Pages should return FALSE
}

void ZoomAndTranslationDocument::OnSize(UINT nType, int cx, int cy) 
{
  CDialog::OnSize(nType, cx, cy);
  if( vg1.m_hWnd )
  {
    vg1.MoveWindow( 0, 0, cx, cy - 60 );
    CWnd* bt = GetDlgItem( IDC_BUTTON1 );
    bt->MoveWindow( 0, cy - 40, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON2 );
    bt->MoveWindow( 100, cy - 40, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON3 );
    bt->MoveWindow( 200, cy - 40, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON4 );
    bt->MoveWindow( 300, cy - 40, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON5 );
    bt->MoveWindow( 400, cy - 40, 100, 20 );
    bt = GetDlgItem( IDC_BUTTON6 );
    bt->MoveWindow( 500, cy - 40, 100, 20 );
  };
}

void ZoomAndTranslationDocument::OnButton1() 
{
  vg1.GetVg().ZoomFit();
}

void ZoomAndTranslationDocument::OnButton2() 
{
  vg1.GetVg().ZoomIn();
}

void ZoomAndTranslationDocument::OnButton3() 
{
  vg1.GetVg().ZoomOut();
}

void ZoomAndTranslationDocument::OnButton4() 
{
  vg1.GetVg().MoveSheet();
}

void ZoomAndTranslationDocument::OnButton5() 
{
  Cvg dlg = vg1.GetVg().Create( vg1.GetDefaultPath() + "smallview.tbl", true, false );
  CSheet sheet = vg1.GetVg().GetActiveSheet();
  VARIANT v;
  v.vt = VT_DISPATCH;
  v.pdispVal = sheet.m_lpDispatch;
  dlg.GetActiveSheet().SetPropertyValue( "cursheet", v );
  POINT p;
  GetCursorPos( &p );
  dlg.Popup(p.x, p.y);
  dlg.Free();
}

void ZoomAndTranslationDocument::OnButton6() 
{
  Cvg vg = vg1.GetVg();
  for (int i = 0; i < vg.GetSheetCount(); i++)
  {
    CSheet st = vg.GetSheets(i);
    int n = st.GetUnitCount();
    for (int j = 0; j < n; j++)
    {
      CUnit d = st.GetUnits(j);
      if (!d.IsElement())
      {
        CString t = d.GetText();
        if(t.GetLength()!=0)
        {
          if (t.Find("building", 0) > -1)
          {
            vg.SetActiveSheet( st );
            vg.SetZoom( d.GetZoomMin() + 1 );
            vg.GetSelection().Clear();
            vg.GetSelection().Add(d);
            double x = d.GetXOrigin();
            double y = d.GetYOrigin();
            vg.ScrollToCenter(x, y);
            MessageBox( t );
            return;
          }
        }
      }
    }
  }
}
